/****************************************************************************
 *
 * /home/bat/bat/fast3202_4_0_21_3_3_1/rg/vendor/adi/ad6843/linux-2.6/kernel/adi_fusiv/bt.c
 * 
 * Copyright (C) Jungo LTD 2004
 * 
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

/* Actaully Sagem specific... but this is a shortcut. */

#include <asm/io.h>
#include <linux/delay.h>

/* These definitions must move to a generic GPIO layer. */
#define GPIO_DIR_OUT	(volatile unsigned short *)0x19040000
#define GPIO_FLAG_CLEAR	(volatile unsigned short *)0x19040004
#define GPIO_FLAG_SET	(volatile unsigned short *)0x19040006
#define GPIO_CTS_MASK	0x4
#define GPIO_BT_RESET_MASK 0x1000

void ad6843_bt_init()
{
    int gpio_dir;
    
    gpio_dir = inw(KSEG1ADDR(GPIO_DIR_OUT));
    gpio_dir |= GPIO_CTS_MASK | GPIO_BT_RESET_MASK;
    outw(gpio_dir, KSEG1ADDR(GPIO_DIR_OUT));
    mdelay(20);

    outw(GPIO_BT_RESET_MASK, KSEG1ADDR(GPIO_FLAG_CLEAR));
    mdelay(20);
    outw(GPIO_BT_RESET_MASK, KSEG1ADDR(GPIO_FLAG_SET));
    mdelay(20);

    outw(GPIO_CTS_MASK, KSEG1ADDR(GPIO_FLAG_SET));
    mdelay(20);
    outw(GPIO_CTS_MASK, KSEG1ADDR(GPIO_FLAG_CLEAR));
}
