/****************************************************************************
 *
 * /home/bat/bat/fast3202_4_0_21_3_3_1/rg/vendor/adi/ad6843/common/kernel/gpio_led_btn.c
 *
 * Copyright (C) Jungo LTD 2004
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * Developed by Jungo LTD.
 * Residential Gateway Software Division
 * www.jungo.com
 * info@jungo.com
 */

#include <asm/io.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <vendor/gpio_layout.h>
#include <vendor/gpio_led_btn.h>
#include <linux/timer.h>
#include <linux/sbi_k.h>

/* This is the physical address of the 2 GPIOs blocks */
#define GPIO_DIR1          ((short *) KSEG1ADDR(0x19040000))
#define GPIO_FLAG1_RESET   ((short *) KSEG1ADDR(0x19040004))
#define GPIO_FLAG1_SET     ((short *) KSEG1ADDR(0x19040006))
//#if defined CONFIG_SAGEM_BOXER || defined CONFIG_SAGEM_FAST34XX
#if ( defined(CONFIG_SAGEM_BOXER) && ! defined(CONFIG_SAGEM_GPIO_ULT_FOR_BOXER_FW) ) || ( defined(CONFIG_SAGEM_LBV2ULT) && defined(CONFIG_SAGEM_GPIO_BOXER_FOR_ULT_FW) ) || defined (CONFIG_SAGEM_FAST34XX)
#define GPIO_INTREN1_RESET   ((short *) KSEG1ADDR(0x19040008))	//invert
#define GPIO_INTREN1_SET ((short *) KSEG1ADDR(0x1904000a))	//
#else
#define GPIO_INTREN1_SET   ((short *) KSEG1ADDR(0x19040008))
#define GPIO_INTREN1_RESET ((short *) KSEG1ADDR(0x1904000a))
#endif
#define GPIO_SRC_POLAR1    ((short *) KSEG1ADDR(0x19040010))

#define GPIO_DIR2          ((short *) KSEG1ADDR(0x190b0000))
#define GPIO_FLAG2_RESET   ((short *) KSEG1ADDR(0x190b0004))
#define GPIO_FLAG2_SET     ((short *) KSEG1ADDR(0x190b0006))
//#if defined CONFIG_SAGEM_BOXER || defined CONFIG_SAGEM_FAST34XX
#if ( defined(CONFIG_SAGEM_BOXER) && ! defined(CONFIG_SAGEM_GPIO_ULT_FOR_BOXER_FW) ) || ( defined(CONFIG_SAGEM_LBV2ULT) && defined(CONFIG_SAGEM_GPIO_BOXER_FOR_ULT_FW) ) || defined (CONFIG_SAGEM_FAST34XX)
#define GPIO_INTREN2_RESET   ((short *) KSEG1ADDR(0x190b0008))	//invert
#define GPIO_INTREN2_SET ((short *) KSEG1ADDR(0x190b000a))	//
#else
#define GPIO_INTREN2_SET   ((short *) KSEG1ADDR(0x190b0008))
#define GPIO_INTREN2_RESET ((short *) KSEG1ADDR(0x190b000a))
#endif
#define GPIO_SRC_POLAR2    ((short *) KSEG1ADDR(0x190b0010))
//#if defined CONFIG_SAGEM_BOXER || defined CONFIG_SAGEM_FAST34XX
#if ( defined(CONFIG_SAGEM_BOXER) && ! defined(CONFIG_SAGEM_GPIO_ULT_FOR_BOXER_FW) ) || ( defined(CONFIG_SAGEM_LBV2ULT) && defined(CONFIG_SAGEM_GPIO_BOXER_FOR_ULT_FW) ) || defined (CONFIG_SAGEM_FAST34XX)
#define GPIO_EDGE2	   ((short *) KSEG1ADDR(0x190b0014))	//FIXME PTM
#endif

#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
struct gpio_access_struct_t gpio_access[GPIO_LAST];
#else // CONFIG_SAGEM_GENERIC_CARD_SUPPORT
#endif //CONFIG_SAGEM_GENERIC_CARD_SUPPORT
static unsigned long	GPIO_MASK_OUTPUT_LINES;
static unsigned long	GPIO_MASK_INPUT_LINES;
static unsigned long	GPIO_MASK_ALL_LINES;
static unsigned long	GPIO_INPUT_NUMBER;
static unsigned long	GPIO_OUTPUT_NUMBER;
static int				already_setup;

/* Private function for accessing registers */
static void gpio_set_register(unsigned short value,unsigned short mask,unsigned short *reg)
{
	volatile short * real_reg=reg;
	*real_reg= (*real_reg & (~mask) ) | (value & mask);
}

static void gpio_set_register_direct(unsigned short value,unsigned short mask,unsigned short *reg)
{
	volatile short * real_reg=reg;
	*real_reg = (value & mask);
}


static unsigned short gpio_get_register(unsigned short mask,unsigned short *reg)
{
	volatile short *real_reg = reg;
	return *real_reg & mask;
}
#ifdef CONFIG_ETH_SWITCH
static void msdelay(long i) {
       for (i = 0; i < 10000000;) i++;
}
#endif

/* Public driver interface */
int gpio_led_btn_setup(void)
{
	int i;

	if (already_setup)
		return 0;
	already_setup = 1;
	GPIO_MASK_OUTPUT_LINES=0;
	GPIO_MASK_INPUT_LINES=0;
	GPIO_MASK_ALL_LINES=0;
	GPIO_INPUT_NUMBER=0;
	GPIO_OUTPUT_NUMBER=0;

		#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	for (i=0;i<GPIO_LAST;i++) {
		if (!gpio_access[i].set_addr)
			continue;
#else
	for (i=0;gpio_access[i].set_addr !=0 ;i++) {
#endif
		if (gpio_access[i].dev_exclude)
			continue;
		if (gpio_access[i].dev_direction == 1) {
			GPIO_OUTPUT_NUMBER++;
			GPIO_MASK_OUTPUT_LINES |= (gpio_access[i].dev_bitmask);
		} else {
			GPIO_INPUT_NUMBER++;
			GPIO_MASK_INPUT_LINES |=  (gpio_access[i].dev_bitmask);
		}
		GPIO_MASK_ALL_LINES |= gpio_access[i].dev_bitmask;
	}
	printk("GPIO Initialisation (led/buttons/relays)\n");

	/* Set output direction lines : write 1 to the led registers, do not touch the rest */
	gpio_set_register(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES>>16),GPIO_DIR2);
	gpio_set_register(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES&0x0000ffff),GPIO_DIR1);

	/* Set input direction lines : write 0 to the buttons direction registers, do not touch the rest */
	gpio_set_register(0,(unsigned short) (GPIO_MASK_INPUT_LINES>>16),GPIO_DIR2);
	gpio_set_register(0,(unsigned short) (GPIO_MASK_INPUT_LINES&0x0000ffff),GPIO_DIR1);

	/* Set input polarity lines : write 0 to the buttons polarity registers, do not touch the rest */
	gpio_set_register(0xffff,(unsigned short) (GPIO_MASK_INPUT_LINES>>16),GPIO_SRC_POLAR2);
	gpio_set_register(0xffff,(unsigned short) (GPIO_MASK_INPUT_LINES&0x0000ffff),GPIO_SRC_POLAR1);

	/* Switch off all leds and switch off relays write 1 to the output registers */
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES>>16),GPIO_FLAG2_RESET);
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES&0x0000ffff),GPIO_FLAG1_RESET);

#ifdef CONFIG_LBR_34XX
	/* Enabling Leds */
	gpio_led_btn_set(GPIO_LEDS_CONFIG);
#endif
	if (IS_CPU_VOX160)
	  {
#if defined(CONFIG_SAGEM_LBV2MINI) || defined(CONFIG_SAGEM_LBV2BABY)
		gpio_led_btn_set(GPIO_RST_LAN_1_N);
		gpio_led_btn_set(GPIO_RST_LAN_2_N);
#endif // defined(CONFIG_SAGEM_LBV2MINI) || defined(CONFIG_SAGEM_LBV2BABY)
#ifdef CONFIG_ETH_SWITCH
//       msdelay(3);
       gpio_led_btn_reset(GPIO_RST_LAN_N);
//       msdelay(1);
       gpio_led_btn_set(GPIO_RST_LAN_N);
//       msdelay(4);
#endif // CONFIG_ETH_SWITCH
	  }

#if ! defined(CONFIG_SAGEM_LBV2BABY)
#ifdef CONFIG_SAGEM_USB_HOST
	/* Enabling USB Host power */
	if (IS_CPU_VOX160) {
		gpio_led_btn_set(GPIO_USBH_PWR_EN);
		gpio_led_btn_set(GPIO_USBH2_PWR_EN);
#if defined(CONFIG_SAGEM_LBV2ULT) || defined(CONFIG_SAGEM_GENERIC_CARD_SUPPORT)
		gpio_led_btn_set(GPIO_USB_HUB_RST);
#endif
	}
#endif
#endif
/* OPN 20071016 bug 7161 : ADSL RED LED BLINKING is configured by "internet_service_notify" */

	gpio_led_btn_set(GPIO_LED_ON);

	return 0;
}


int gpio_led_btn_close(void)
{
	if (already_setup == 0)
		return 0;
	already_setup=0;
	/* Switch off all leds and switch off relays */
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES>>16),GPIO_FLAG2_RESET);
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES&0x0000ffff),GPIO_FLAG1_RESET);
	return 0;
}

int gpio_led_btn_set(GPIO_Devices_t device_number)
{
	if (device_number<0 || (device_number>=(sizeof(gpio_access)/sizeof(gpio_access[0]))))
		return -1;

	#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	if (!gpio_access[device_number].set_addr) {
		return -1;
	}
	#endif

	if (gpio_access[device_number].dev_direction != 1)
		return -1;
#ifdef CONFIG_LBR_34XX
	if (device_number == GPIO_LED_WAN && 
	    blinking_is_activated /*&& 
            !gpio_led_btn_read(GPIO_LEDS_CONFIG)*/) 
		gpio_led_btn_set(GPIO_LEDS_CONFIG);
#endif /*CONFIG_LBR_34XX*/
	gpio_set_register_direct(0xffff,
			gpio_access[device_number].dev_bitmask>>gpio_access[device_number].dev_offset,
			gpio_access[device_number].set_addr);
	return 0;
}

int gpio_led_btn_reset(GPIO_Devices_t device_number)
{
	if (device_number<0 || (device_number>=(sizeof(gpio_access)/sizeof(gpio_access[0]))))
		return -1;

	#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	if (!gpio_access[device_number].set_addr) {
		return -1;
	}
	#endif

	if (gpio_access[device_number].dev_direction != 1)
		return -1;
#ifdef CONFIG_LBR_34XX
	if (device_number == GPIO_LED_WAN && 
            blinking_is_activated /*&& 
            !gpio_led_btn_read(GPIO_LEDS_CONFIG)*/)  
		gpio_led_btn_set(GPIO_LEDS_CONFIG);
#endif /*CONFIG_LBR_34XX*/
	gpio_set_register_direct(0xffff,
			gpio_access[device_number].dev_bitmask>>gpio_access[device_number].dev_offset,
			gpio_access[device_number].reset_addr);
	return 0;
}

int gpio_led_btn_toggle(GPIO_Devices_t device_number)
{
	unsigned short old_val;

	if (device_number<0 || (device_number>=(sizeof(gpio_access)/sizeof(gpio_access[0]))))
		return -1;

	#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	if (!gpio_access[device_number].set_addr) {
		return -1;
	}
	#endif

	if (gpio_access[device_number].dev_direction != 1)
		return -1;
	old_val = gpio_get_register(gpio_access[device_number].dev_bitmask>>gpio_access[device_number].dev_offset,
						        gpio_access[device_number].set_addr);
	if (old_val)
		gpio_led_btn_reset(device_number);
	else
		gpio_led_btn_set(device_number);
	return 0;
}

int gpio_led_btn_read(GPIO_Devices_t device_number)
{
	unsigned short val=0;

	if ( device_number<0 || (device_number>=(sizeof(gpio_access)/sizeof(gpio_access[0]))))
		return -1;

	#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	if (!gpio_access[device_number].set_addr) {
		return -1;
	}
	#endif

	val=gpio_get_register(gpio_access[device_number].dev_bitmask>>gpio_access[device_number].dev_offset,
			              gpio_access[device_number].set_addr);
	if (val)
		return 1;
	return 0;
}

unsigned long gpio_led_btn_get_all_input(void)
{
	return  ((gpio_get_register((unsigned short) (GPIO_MASK_INPUT_LINES>>16),GPIO_FLAG2_SET)) <<16) +
			(gpio_get_register((unsigned short) (GPIO_MASK_INPUT_LINES&0x0000ffff),GPIO_FLAG1_SET)) ;
}

void gpio_led_btn_set_all_output(unsigned long set_value)
{
	/* "Sticky" register: First write 1 to reset lines to clear bits, and then write 1 to set in the SET register */
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES>>16),GPIO_FLAG2_RESET);
	gpio_set_register_direct(0xffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES&0x0000ffff),GPIO_FLAG1_RESET);

	gpio_set_register_direct(set_value >> 16 ,(unsigned short) (GPIO_MASK_OUTPUT_LINES>>16),GPIO_FLAG2_SET);
	gpio_set_register_direct(set_value & 0x0000ffff,(unsigned short) (GPIO_MASK_OUTPUT_LINES&0x0000ffff),GPIO_FLAG1_SET);

	return;
}

/*  Procfs access */
#include <linux/module.h>
#include <linux/init.h>
#include <linux/device.h>
#include <linux/proc_fs.h>

#define PROC_DIR "driver/gpio"
#define PROC_PATH "bits"
static struct proc_dir_entry *procdir;


static int read_but(char *page,
		char **start, off_t off, int count, int *eof, void *data)
{
	char *p = page;
	int i;

	*start = NULL;
	*eof = 1;
	if (off != 0)
		return 0;

	for(i=GPIO_LAST-1; i >= 0 ; i--) {
		if (gpio_access[i].name) {
			p+=sprintf(p, "bit%x=%d (%s)\n", i ,gpio_led_btn_read(i),gpio_access[i].name);
		}
	}
	return p - page;
}

static int is_digit(char c)
{
  if ((c >= '0') && (c <= '9'))
    return 1;
  return 0;
}

static int is_lower(char c)
{
  if ((c >= 'a') && (c <= 'z'))
    return 1;
  return 0;
}

static int write_led (struct file *file, const char __user *buf,
		unsigned long count, void *data)
{
	char ker_buf [7];
	int bit, val, tmp;
	if (count < 6)
		return -EINVAL;
	if (copy_from_user(ker_buf, buf, count))
		return -EFAULT;

	if (memcmp(ker_buf, "bit", 3) ||
	    ((ker_buf[4] != '=') && (ker_buf[5] != '=')))
	  {
	    printk("usage: echo bit<N>=<value> > /proc/driver/gpio/bits\n");
	    return -EINVAL;
	  }

	if (ker_buf[4] == '=')
	  {
	    if (is_digit(ker_buf[3]))
	      bit = ker_buf[3] - '0';
	    else if (is_lower(ker_buf[3]))
	      bit = ker_buf[3] - 'a' + 10;
	    else
	      {
		printk("usage: bit is alpha or minus\n");
		return -EINVAL;
	      }

	    val = ker_buf[5] - '0';
	  }
	else if (ker_buf[5] == '=')
	  {
	    if (is_digit(ker_buf[3]))
	      tmp = (ker_buf[3] - '0') * 16;
	    else if (is_lower(ker_buf[3]))
	      tmp = (ker_buf[3] - 'a' + 10) * 16;
	    else
	      {
		printk("usage: bit is alpha or minus\n");
		return -EINVAL;
	      }


	    if (is_digit(ker_buf[4]))
	      bit = tmp + (ker_buf[4] - '0');
	    else if (is_lower(ker_buf[4]))
	      bit = tmp + (ker_buf[4] - 'a' + 10);
	    else
	      {
		printk("usage: bit is alpha or minus\n");
		return -EINVAL;
	      }

	    val = ker_buf[6] - '0';
	  }
	else
	  {
	    printk("usage: echo bit<N>=<value> > /proc/driver/gpio/bits\n");
	    return -EINVAL;
	  }

	//	printk("setting bit %d to value %d\n", bit, val);

	if (val==0)
		gpio_led_btn_reset(bit);
	else if (val==1)
		gpio_led_btn_set(bit);
	else
		gpio_led_btn_toggle(bit);

	return count;
}

/* IOCTL interface */
#include <vendor/gpio_led_btn_chardev.h>
#include <linux/types.h>
#include <linux/fs.h>
#include <linux/cdev.h>


static struct file_operations gpio_led_btn_fops;
struct cdev   gpio_led_btn_cdev;

#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT

static struct proc_dir_entry *procdir_hardware;

int gpio_get_card_id(void)
{
	static int cardId=-1;

	if (cardId==-1) {
		int gpio_value = (gpio_led_btn_read(GPIO_CONFIG_2)<<2) | (gpio_led_btn_read(GPIO_CONFIG_1)<<1) | gpio_led_btn_read(GPIO_CONFIG_0);
		if (gpio_value==7) {
			cardId=CARDID_LIVEBOX2;
		}
		else if (gpio_value==0) {
			//if (!strncmp((char*)0xbf018064, "Ultimate", 8)) {
			//	cardId=CARDID_LBV2ULT;
			//}
			//else {
				cardId=CARDID_FTTHV2;
			//}
		}
	}
	return cardId;
}

static int read_hardware_type (char *page, char **start, off_t off, int count, int *eof, void *data)
{
	char *p = page;

	*start = NULL;
	*eof = 1;
	if (off != 0)
		return 0;
	p+=sprintf(p, "%d\n", gpio_get_card_id());
	return p - page;
}
EXPORT_SYMBOL(gpio_get_card_id);

static void setGpioConfig(int gpio, int gpioNum, int dir, int polarity, int interrupt, int ext_driven, char *name) {
	gpio_access[gpio].set_addr=(gpioNum<16)? GPIO_FLAG1_SET:GPIO_FLAG2_SET;
	gpio_access[gpio].reset_addr=(gpioNum<16)? GPIO_FLAG1_RESET:GPIO_FLAG2_RESET;
	gpio_access[gpio].dev_bitmask=1<<gpioNum;
	gpio_access[gpio].dev_offset=(gpioNum<16)? 0 : 16;
	gpio_access[gpio].dev_direction=dir;
	gpio_access[gpio].polarity=polarity;
	gpio_access[gpio].interruption=interrupt;
	gpio_access[gpio].dev_exclude=ext_driven;
	strcpy (gpio_access[gpio].name, name);
}

#define PROC_DIR_HARDWARE_TYPE "bits/hardware"

static void initGenericGpio(void) {
	struct proc_dir_entry *pde;

	memset(&gpio_access, 0, sizeof(gpio_access));
	setGpioConfig(GPIO_CONFIG_0,      4, 0, 1, 0, 1, "4: Config Bit 1 (in)");
	setGpioConfig(GPIO_CONFIG_1,      5, 0, 1, 0, 1, "5: Config Bit 2 (in)");
	setGpioConfig(GPIO_CONFIG_2,      6, 0, 1, 0, 1, "6: Config Bit 3 (in)");
	setGpioConfig(GPIO_LED_WIRLS,     7,  1, 1, 0, 0, "7: Wifi Led (in/out)");
	setGpioConfig(GPIO_LED_PHONE,     8,  1, 1, 0, 0, "8: Phone Led (in/out)");
	setGpioConfig(GPIO_LED_LAN,       9,  1, 1, 0, 0, "9: Lan Led (in/out)");
	setGpioConfig(GPIO_LED_WAN_RED,   10, 1, 1, 0, 0, "10: WAN Led Red (in/out)");
	setGpioConfig(GPIO_LED_ON,        11, 1, 1, 0, 0, "11: Power On Led (in/out)");
	setGpioConfig(GPIO_CMD_NL,        13, 1, 1, 0, 1, "13: Load command for CLIP (out)");
	setGpioConfig(GPIO_AFE_RST_N,     16, 1, 1, 0, 1, "16: AFE reset (active low) (out)");
	setGpioConfig(GPIO_SUR_I_VUSBH,   17, 0, 1, 0, 1, "17: Overcurrent detection on VUSBH (in)");
	setGpioConfig(GPIO_FXS_EXT_LINE1, 19, 1, 1, 0, 0, "19: Line 1 relay (Active low) (out)");
	setGpioConfig(GPIO_RST_CONFIG_N,  24, 0, 1, 0, 0, "24: Default Config Button (Active low) (in)");
	setGpioConfig(GPIO_ASSOC_WIFI_N,  26, 0, 1, 0, 0, "26: Wifi association button (in)");
	setGpioConfig(GPIO_LED_WAN_GRN,   27, 1, 1, 0, 0, "27: WAN Led Green (in/out)");
	printk ("####### detected generic cardid %d\n",gpio_get_card_id());
	switch (gpio_get_card_id()) {
		#ifdef CONFIG_SAGEM_FTTHV2
		case  CARDID_FTTHV2:
		case  CARDID_LIVEBOX2:
			setGpioConfig(GPIO_SPI_CS_Z_N,       1, 1, 1, 0, 1, "1: FXS SPI Chip Select (Active low) (out)");
			setGpioConfig(GPIO_SPI_CS_FXO_N,     2, 1, 1, 0, 1, "2: FXO Chip Select (Active low) (out)");
			setGpioConfig(GPIO_RST_Z_N,          3, 1, 1, 0, 1, "3: FXSs, FXO devices reset (Active low) (out)");
											// 	12 Not used	
      		setGpioConfig(GPIO_FXS_EXT_LINE2,  	14, 1, 1, 0, 0, "14: Line 2 relay (Active low) (out)");
      		setGpioConfig(GPIO_USBH_PWR_EN,    	15, 1, 1, 0, 0, "15: USB Host Power Enable (Active High) (out)");
											// 	18 Not used	
			setGpioConfig(GPIO_MII_DEDICATED1, 	20, 0, 1, 0, 1, "20: Dedicated MII2 Interface");
			setGpioConfig(GPIO_MII_DEDICATED2, 	21, 0, 1, 0, 1, "21: Dedicated MII2 Interface");
			setGpioConfig(GPIO_MII_DEDICATED3, 	22, 0, 1, 0, 1, "22: Dedicated MII2 Interface");
			setGpioConfig(GPIO_MII_DEDICATED4, 	23, 0, 1, 0, 1, "23: Dedicated MII2 Interface");
			setGpioConfig(GPIO_DYING_GASP_N,   	25,0,1,1,0,"25: Power fall warning for dying gasp function (active low /in)");
      		setGpioConfig(GPIO_RST_LAN_N,      	28,1,1,0,1,"28: Ethernet Switch Reset (active low) (out)");
			setGpioConfig(GPIO_CMD_POWER_OFF,  	29,1,1,0,1,"29: Command Power Off (active low) (out)");
			setGpioConfig(GPIO_POWER_OFF_N,    	30, 0, 0, 0, 0, "30: Reboot gateway: short press=reboot, long press= On/Off (in)");
			setGpioConfig(GPIO_LED_DWNLD,      	31, 1, 1, 0, 0, "31: Update Blue Led (in/out)");
			if (gpio_get_card_id()==CARDID_LIVEBOX2) {
			setGpioConfig(GPIO_USB_HUB_RST,	   	12, 1, 1, 0, 0, "12: Reset Hub Usb (active High) (out)");
      		setGpioConfig(GPIO_USBH2_PWR_EN,	18, 1, 1, 0, 0, "18: USB Host 2 Power Enable (Active High) (out)");
			}
			break;
		#endif
		#if 0 //def CONFIG_SAGEM_LBV2ULT
		case CARDID_LBV2ULT:
			setGpioConfig(GPIO_RST_Z_N,         0, 1, 1, 0, 1, "0: FXSs, FXO devices reset (Active low) (out)");
			setGpioConfig(GPIO_BAD_POS_N,		3, 0, 1, 0, 0, "3: Bad position notofication (Active low) (in)");
			setGpioConfig(GPIO_CMD_POWER_OFF,   6, 1, 1, 0, 1, "6: Command Power Off (active low) (out)");
			setGpioConfig(GPIO_LED_HDD,		   12, 1, 1, 0, 0, "12: Hdd Led (out)");
      		setGpioConfig(GPIO_USB_HUB_RST,    14, 1, 0, 0, 0, "14: USB Hub Reset (out)"); // USB_HUB_RST
			setGpioConfig(GPIO_POWER_OFF_N,    18, 0, 0, 0, 0, "18: Reboot gateway: short press=reboot, long press= On/Off (in)");
			setGpioConfig(GPIO_LED_DWNLD,      25, 1, 1, 0, 0, "25: Update Blue Led (in/out)");
			setGpioConfig(GPIO_DYING_GASP_N,   28, 0, 1, 1, 0, "28: Power fall warning for dying gasp function (active low /in)");
      		setGpioConfig(GPIO_RST_LAN_N,      29, 1, 1, 0, 1, "29: Ethernet Switch Reset (active low) (out)");
			setGpioConfig(GPIO_ALT_WINFIN_INT, 30, 0, 0, 0, 0, "30: Alternate Wifi interruption");
			setGpioConfig(GPIO_CP_USB_HDD,     31, 0, 0, 0, 0, "31: Button Copy USB to HDD (in)");
			break;
		#endif
	}


	/* Procfs initialisation */
	pde = create_proc_read_entry("hardware", 0, procdir, read_hardware_type, NULL);
}
#endif // CONFIG_SAGEM_GENERIC_CARD_SUPPORT

int gpio_led_btn_ioctl_handler(struct inode * the_inode, struct file *the_file, unsigned int cmd, unsigned long arg)
{
  struct lb2_gpio_ioctl_request_t req;

  if (cmd != GPIO_LED_BTN_IOCTL_CMD_NUMBER)
	return -ENOTTY;
  if ( copy_from_user(&req,(void*)arg,sizeof(req)))
	return -EFAULT;
  switch (req.request_type) {
	  case GPIO_GET_REQUEST:
		if ((req.bit_number <0) || (req.bit_number >= GPIO_LAST))
		  return -EINVAL;
		req.bit_value = gpio_led_btn_read(req.bit_number);
		break;
	  case GPIO_SET_REQUEST:
		if ((req.bit_number <0) || (req.bit_number >= GPIO_LAST))
		  return -EINVAL;
		if (req.bit_value)
		{
		  req.bit_value=gpio_led_btn_set(req.bit_number);
		}
		else
		  req.bit_value=gpio_led_btn_reset(req.bit_number);
		break;
	  #ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	  case GPIO_GET_HARDWARE:
	  	req.bit_value=gpio_get_card_id();	
	  	break;
	  #endif
	// case GPIO_STOP_BLINKING: /* OPN 20071016 bug 7161 : ADSL RED LED BLINKING is configured by "internet_service_notify" */
	  default:
		return -EINVAL;
  }
  if (copy_to_user((void *)arg,&req,sizeof(req)))
	return -EFAULT;
  return 0;
}

/* Module management */

static int __init init(void)
{
	struct proc_dir_entry *pde;
	int err;

	/* Procfs initialisation */
	procdir = proc_mkdir(PROC_DIR, NULL);

	pde = create_proc_read_entry(PROC_PATH,
			0, procdir, read_but, NULL);
	if (pde) {
		pde->owner = THIS_MODULE;
		pde->write_proc = write_led;
	} else {
		printk("gpio_led_btn: Warning, procfs interface failed to initialize.\n");
	}
	/* character device init */
	memset(&gpio_led_btn_fops,0,sizeof(gpio_led_btn_fops));
	gpio_led_btn_fops.ioctl = gpio_led_btn_ioctl_handler;
	gpio_led_btn_fops.owner = THIS_MODULE;

	err = register_chrdev(GPIO_LED_BTN_MAJOR,GPIO_LED_BTN_NAME,&gpio_led_btn_fops);
	if (err) {
		printk("gpio_led_btn: Warning, character device interface failed to initialize, \
		register_chrdev = %d\n",err);
	}
	#ifdef CONFIG_SAGEM_GENERIC_CARD_SUPPORT
	initGenericGpio();
	#endif
   	if (gpio_led_btn_setup() != 0){
		printk("gpio_led_btn: Warning, driver failed to initialize.\n");
		remove_proc_entry(PROC_PATH, procdir);
		remove_proc_entry(PROC_DIR, NULL);
		err = unregister_chrdev(GPIO_LED_BTN_MAJOR,GPIO_LED_BTN_NAME);
		return -1;
	}
	return 0;
}

static void __exit exit(void)
{
	gpio_led_btn_close();
	remove_proc_entry(PROC_PATH, procdir);
	remove_proc_entry(PROC_DIR, NULL);
	cdev_del(&gpio_led_btn_cdev);
	unregister_chrdev(GPIO_LED_BTN_MAJOR,GPIO_LED_BTN_NAME);
}

module_init(init);
module_exit(exit);
MODULE_LICENSE("SAGEM");
MODULE_AUTHOR("SAGEM");
MODULE_DESCRIPTION("LED and BUTTON driver");

EXPORT_SYMBOL(gpio_led_btn_setup);
EXPORT_SYMBOL(gpio_led_btn_close);
EXPORT_SYMBOL(gpio_led_btn_set);
EXPORT_SYMBOL(gpio_led_btn_reset);
EXPORT_SYMBOL(gpio_led_btn_toggle);
EXPORT_SYMBOL(gpio_led_btn_read);
EXPORT_SYMBOL(gpio_led_btn_get_all_input);
EXPORT_SYMBOL(gpio_led_btn_set_all_output);
